#include "su.h"
#include "segy.h"

#include <assert.h>

/*********************** self documentation **********************/
char *sdoc[] = {
"								",
" Time Derivative",
"								",
"							        ",
NULL};
/**************** end self doc ***********************************/

segy tr;

int
main(int argc, char **argv)
{
	int itr,nt;
	int verbose;
	double dt,odt;
	
	/* Initialize */
	initargs(argc, argv);
	requestdoc(1);

	verbose=1;	getparint("verbose",&verbose);

	/* Get info from first trace */
	itr = gettr(&tr);
	if(verbose>1) fprintf(stderr,"First gettr returned %d\n",itr);
	if(!itr) warn ("can't get first trace");
	assert(itr);

	nt = tr.ns;
	assert(nt>=0);

	if(tr.dt) dt = tr.dt/1000000.0;
	else {
		dt = 1.0;
		warn("Zero dt on input data.  Setting dt=%g",dt);
	}
	odt = 1.0/dt;
	if(verbose) fprintf(stderr,"dt=%g odt=%g\n",dt,odt);
	
	/* Loop over traces */
	itr = 1;			/* First trace already in */
	do {
		int it;

		if(tr.ns!=nt) warn("tr.ns changed");

		for(it=nt;it>0;it--) {
			tr.data[it] -= tr.data[it-1];
			tr.data[it] *= odt;
		}

		puttr(&tr);

		itr++;

	} while (gettr(&tr));

	return 0;
}
